/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.Keys;
import de.ship.db.tables.TCoreLogic.TCoreLogicPath;
import de.ship.db.tables.TCoreTranslationKey.TCoreTranslationKeyPath;
import de.ship.db.tables.records.TCoreLogictypeRecord;

import java.time.LocalDateTime;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.InverseForeignKey;
import org.jooq.Name;
import org.jooq.Path;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.Record;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TCoreLogictype extends TableImpl<TCoreLogictypeRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.t_core_logictype</code>
     */
    public static final TCoreLogictype T_CORE_LOGICTYPE = new TCoreLogictype();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TCoreLogictypeRecord> getRecordType() {
        return TCoreLogictypeRecord.class;
    }

    /**
     * The column <code>common_dd.t_core_logictype.pk_core_logictype</code>.
     */
    public final TableField<TCoreLogictypeRecord, Integer> PK_CORE_LOGICTYPE = createField(DSL.name("pk_core_logictype"), SQLDataType.INTEGER.nullable(false).identity(true), this, "");

    /**
     * The column <code>common_dd.t_core_logictype.logictype</code>. type of
     * logic
     */
    public final TableField<TCoreLogictypeRecord, Integer> LOGICTYPE = createField(DSL.name("logictype"), SQLDataType.INTEGER.nullable(false), this, "type of logic");

    /**
     * The column <code>common_dd.t_core_logictype.logictype_descr</code>.
     * language key for logic type
     */
    public final TableField<TCoreLogictypeRecord, String> LOGICTYPE_DESCR = createField(DSL.name("logictype_descr"), SQLDataType.CLOB.nullable(false), this, "language key for logic type");

    /**
     * The column <code>common_dd.t_core_logictype.lastchange</code>.
     */
    public final TableField<TCoreLogictypeRecord, LocalDateTime> LASTCHANGE = createField(DSL.name("lastchange"), SQLDataType.LOCALDATETIME(6).defaultValue(DSL.field(DSL.raw("now()"), SQLDataType.LOCALDATETIME)), this, "");

    private TCoreLogictype(Name alias, Table<TCoreLogictypeRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private TCoreLogictype(Name alias, Table<TCoreLogictypeRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table(), where);
    }

    /**
     * Create an aliased <code>common_dd.t_core_logictype</code> table reference
     */
    public TCoreLogictype(String alias) {
        this(DSL.name(alias), T_CORE_LOGICTYPE);
    }

    /**
     * Create an aliased <code>common_dd.t_core_logictype</code> table reference
     */
    public TCoreLogictype(Name alias) {
        this(alias, T_CORE_LOGICTYPE);
    }

    /**
     * Create a <code>common_dd.t_core_logictype</code> table reference
     */
    public TCoreLogictype() {
        this(DSL.name("t_core_logictype"), null);
    }

    public <O extends Record> TCoreLogictype(Table<O> path, ForeignKey<O, TCoreLogictypeRecord> childPath, InverseForeignKey<O, TCoreLogictypeRecord> parentPath) {
        super(path, childPath, parentPath, T_CORE_LOGICTYPE);
    }

    /**
     * A subtype implementing {@link Path} for simplified path-based joins.
     */
    public static class TCoreLogictypePath extends TCoreLogictype implements Path<TCoreLogictypeRecord> {

        private static final long serialVersionUID = 1L;
        public <O extends Record> TCoreLogictypePath(Table<O> path, ForeignKey<O, TCoreLogictypeRecord> childPath, InverseForeignKey<O, TCoreLogictypeRecord> parentPath) {
            super(path, childPath, parentPath);
        }
        private TCoreLogictypePath(Name alias, Table<TCoreLogictypeRecord> aliased) {
            super(alias, aliased);
        }

        @Override
        public TCoreLogictypePath as(String alias) {
            return new TCoreLogictypePath(DSL.name(alias), this);
        }

        @Override
        public TCoreLogictypePath as(Name alias) {
            return new TCoreLogictypePath(alias, this);
        }

        @Override
        public TCoreLogictypePath as(Table<?> alias) {
            return new TCoreLogictypePath(alias.getQualifiedName(), this);
        }
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public Identity<TCoreLogictypeRecord, Integer> getIdentity() {
        return (Identity<TCoreLogictypeRecord, Integer>) super.getIdentity();
    }

    @Override
    public UniqueKey<TCoreLogictypeRecord> getPrimaryKey() {
        return Keys.PK_CORE_LOGICTYPE;
    }

    @Override
    public List<UniqueKey<TCoreLogictypeRecord>> getUniqueKeys() {
        return Arrays.asList(Keys.UK_LOGICTYPE);
    }

    @Override
    public List<ForeignKey<TCoreLogictypeRecord, ?>> getReferences() {
        return Arrays.asList(Keys.T_CORE_LOGICTYPE__FK_LOGICTYPE_DESCR);
    }

    private transient TCoreTranslationKeyPath _tCoreTranslationKey;

    /**
     * Get the implicit join path to the
     * <code>common_dd.t_core_translation_key</code> table.
     */
    public TCoreTranslationKeyPath tCoreTranslationKey() {
        if (_tCoreTranslationKey == null)
            _tCoreTranslationKey = new TCoreTranslationKeyPath(this, Keys.T_CORE_LOGICTYPE__FK_LOGICTYPE_DESCR, null);

        return _tCoreTranslationKey;
    }

    private transient TCoreLogicPath _tCoreLogic;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_core_logic</code> table
     */
    public TCoreLogicPath tCoreLogic() {
        if (_tCoreLogic == null)
            _tCoreLogic = new TCoreLogicPath(this, null, Keys.T_CORE_LOGIC__FK_LOGICTYPE.getInverseKey());

        return _tCoreLogic;
    }

    @Override
    public TCoreLogictype as(String alias) {
        return new TCoreLogictype(DSL.name(alias), this);
    }

    @Override
    public TCoreLogictype as(Name alias) {
        return new TCoreLogictype(alias, this);
    }

    @Override
    public TCoreLogictype as(Table<?> alias) {
        return new TCoreLogictype(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreLogictype rename(String name) {
        return new TCoreLogictype(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreLogictype rename(Name name) {
        return new TCoreLogictype(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreLogictype rename(Table<?> name) {
        return new TCoreLogictype(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreLogictype where(Condition condition) {
        return new TCoreLogictype(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreLogictype where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreLogictype where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreLogictype where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreLogictype where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreLogictype where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreLogictype where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreLogictype where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreLogictype whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreLogictype whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
